发 帖  
[经验] 移植tslib库出现selected device is not a touchscreen I understand的解决方法
2018-1-23 15:51:47  3091 linux驱动 触摸屏
分享
本帖最后由 weidongshan 于 2018-1-23 16:10 编辑

首发平台:微信公众号baiwenkeji

很多人在做触摸屏驱动实验,移植tslib库时,可能会出现错误提示“selected device is nota touchscreen I understand"

为什么会这样?原因非常简单:tslib中的输入系统和内核input系统版本不匹配,当然也有其他原因,不过这是最常见的情况,先分析一下tslib代码,观察这句话在什么情况下被打印就知道了。

将tslib库中c和H文件加入SourceInsight,跟踪源码发现,在 input-raw.c文件中有这么一段代码:
static int check_fd(structtslib_input *i)
{
struct tsdev *ts =i->module.dev;
int version;
u_int32_t bit;
u_int64_t absbit;

if (!((ioctl(ts->fd, EVIOCGVERSION, &version) >= 0) &&
(version ==EV_VERSION) &&
(ioctl(ts->fd,EVIOCGBIT(0, sizeof(bit) * 8), &bit) >= 0) &&
(bit & (1<< EV_ABS)) &&
(ioctl(ts->fd,EVIOCGBIT(EV_ABS, sizeof(absbit) * 8), &absbit) >= 0) &&
(absbit & (1<< ABS_X)) &&
(absbit & (1<< ABS_Y)) && (absbit & (1 << ABS_PRESSURE)))) {
fprintf(stderr,"selected device is not a touchscreen I understand\n");
return -1;
}
if (bit & (1<< EV_SYN))
i->using_syn =1;
return 0;
}

其中关键的是version == EV_VERSION这个判断语句,如果这俩不等,那么就会打印出selected device is not a touchscreen I understand。

tslib中的input版本号是在交叉编译的时候指定的,赋值给version,而EV_VERSION是在内核中定义,笔者做tslib时,用的2.6.39内核,这个EV_VERSION定义在linux源码的include/linux/input.h中,值是0x010001,而tslib中的version是和交叉编译器相同,查看编译器,在/usr/local/arm/4.3.2/arm-none-linux-gnueabi/libc/usr/include/linux/input.h中,值是0x010000,这俩明显不相等,当然不会满足version ==EV_VERSION,所以导致错误。

所以,以下提供两种解决方法

1.将内核源代码里的include/linux/input.h中的
#define EV_VERSION0x010001
改为:
#define EV_VERSION0x010000

2.将arm交叉编译工具中的头文件库中的
linux/input.h中的
#define EV_VERSION0x010000
改为
#define EV_VERSION0x010001
然后再编译tslib库

一般第一种就可以解决问题,因此,出现上面情况时,先不要急于换版本,如果二者版本不等,那么改一个就可以, 前提是二者版本相同
1
显示全部楼层
· 2018-3-3 13:16:08
大神学习了 厉害厉害厉害啊啊啊啊
· 2018-4-13 09:10:27
学习大神。。。
· 2018-6-19 09:46:44
学习了

只有小组成员才能发言,加入小组>>

133个成员聚集在这个小组

加入小组

创建小组步骤

关闭

站长推荐 上一条 /7 下一条

快速回复 返回顶部 返回列表